﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Net;
using System.Net.Sockets;
using System.Text;
using System.Threading;
using System.Windows.Forms;

namespace Client
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        Socket socketClient;
        //连接服务器
        private void btnStart_Click(object sender, EventArgs e)
        {
            IPAddress ip = IPAddress.Parse(txtServer.Text);
            IPEndPoint point = new IPEndPoint(ip, Convert.ToInt32(txtPort.Text));
            socketClient = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);

            try
            {
                //连接服务端
                socketClient.Connect(point);
                ShowMsg("连接服务器成功");

                //新建线程用于接收
                Thread th = new Thread(Rec);
                th.IsBackground = true;
                th.Start();
            }
            catch (Exception ex)
            {
                ShowMsg(ex.Message);
            }
        }

        //接收
        void Rec()
        {
            while (true)
            {
                try
                {
                    byte[] buffer = new byte[1024 * 1024 * 5];
                    int r = socketClient.Receive(buffer);
                    if (r <= 0)
                    {
                        break;
                    }
                    if (buffer[0] == 0)//消息
                    {
                        ShowMsg(socketClient.RemoteEndPoint.ToString() + ":" + System.Text.Encoding.UTF8.GetString(buffer, 1, r - 1));
                    }
                    else if (buffer[0] == 1)//文件
                    {
                        SaveFileDialog sfd = new SaveFileDialog();
                        if (sfd.ShowDialog(this) == DialogResult.OK)
                        {
                            string path = sfd.FileName;
                            using (FileStream fsWrite = new FileStream(path, FileMode.OpenOrCreate, FileAccess.Write))
                            {
                                fsWrite.Write(buffer, 51, r - 1);
                            }
                            ShowMsg(socketClient.RemoteEndPoint.ToString() + ":文件保存成功... " + path);
                        }
                    }
                    else if (buffer[0] == 2)//震动
                    {
                        this.TopMost = true;//设置窗体到最顶层
                        //获取当前窗口左上角坐标
                        Point p = this.Location;
                        int n = 5;
                        for (int i = 0; i < 10; i++)
                        {
                            this.Location = new Point(p.X + n, p.Y + n);
                            Thread.Sleep(50);
                            this.Location = new Point(p.X - n, p.Y - n);
                            Thread.Sleep(50);
                        }
                        //回到原点
                        this.Location = p;
                        this.TopMost = false;
                    }
                }
                catch
                {
                    ShowMsg(socketClient.RemoteEndPoint.ToString() + ":与服务器断开连接...");
                    break;
                }
            }
        }

        //追加消息
        void ShowMsg(string msg)
        {
            txtLog.AppendText(msg + "\r\n");
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Control.CheckForIllegalCrossThreadCalls = false;
        }

        //客户端发送消息
        private void btnSend_Click(object sender, EventArgs e)
        {
            try
            {
                string str = txtMsg.Text;
                byte[] buffer = System.Text.Encoding.UTF8.GetBytes(str);
                //byte[] bufferSend = new byte[buffer.Length + 1];
                //bufferSend[0] = 0;//消息
                //Buffer.BlockCopy(buffer, 0, bufferSend, 1, buffer.Length);
                //socketClient.Send(bufferSend);
                List<byte> list = new List<byte>();
                list.Add(0);//消息
                list.AddRange(buffer);
                socketClient.Send(list.ToArray());
            }
            catch
            {
                ShowMsg("请确定服务器是否连接成功...");
            }
        }

        //选择文件
        private void btnSelect_Click(object sender, EventArgs e)
        {
            OpenFileDialog ofd = new OpenFileDialog();
            if (ofd.ShowDialog() == DialogResult.OK)
            {
                txtPath.Text = ofd.FileName;
            }
        }

        //发送文件
        private void btnSendFile_Click(object sender, EventArgs e)
        {
            try
            {
                using (FileStream fsRead = new FileStream(txtPath.Text, FileMode.Open, FileAccess.Read))
                {
                    byte[] buffer = new byte[1024 * 1024 * 5];
                    //实际读到的字节数
                    int r = fsRead.Read(buffer, 0, buffer.Length);
                    byte[] bufferSend = new byte[r + 1];
                    bufferSend[0] = 1;//文件
                    Buffer.BlockCopy(buffer, 0, bufferSend, 1, r);
                    socketClient.Send(bufferSend);
                }
                ShowMsg("文件发送完成");
            }
            catch
            {
                ShowMsg("请确定服务器是否连接成功...");
            }
        }
    }
}
